<!-- Nav -->
<%- include('../partials/nav', {active: "vault" }); %>

<div class="container-fluid">
    <div class="row d-flex d-md-block flex-nowrap wrapper">
        <main class="col-12 float-left col px-5 px-md-3 py-3 main">
            <h1>
                Vault Initialization
            </h1>
            <% include ../partials/messages %>
            <div class="my-3 p-3 bg-white rounded shadow-sm">

                <div class="card">
                    <div class="card-body">
                        <h5 class="card-title">Vault has been initialized! Here is your key.</h5>
                        <p class="card-text">Please securely distribute the keys below. When the Vault is
                            re-sealed, restarted, or stopped, you must provide at least <strong class="text-danger">
                                <%=vaultkeyThreshold%>
                            </strong> of these keys to
                            unseal it again. Vault does not store the master key. Without at least <strong class="text-danger">
                                <%=vaultkeyThreshold%>
                            </strong> keys, your
                            Vault will remain permanently sealed.</p>
                        <button class="btn btn-success"
                            onclick="downloadKeys('<%=JSON.stringify(vaultKeys)%>', '<%= (new Date()).toISOString() %>');displayUnsealBtn()">Download
                            keys</button>
                        <a id="unsealNavBtn" href="/vault/unseal" class="btn btn-primary d-none">Continue to Unseal</a>
                    </div>
                </div>

            </div>
        </main>
    </div>
</div>


<script>

    function downloadKeys(keys, datetimeString) {

        //Beautify JSON file
        keys = JSON.stringify(JSON.parse(keys), null, 2);
        let blob = new Blob([keys], { type: "application/json" });
        let url = window.URL.createObjectURL(blob);
        let filename = `vault-${datetimeString.replaceAll(':', '_')}.json`;

        let element = document.createElement('a');
        element.setAttribute('href', url);
        element.setAttribute('download', filename);
        element.style.display = 'none';
        document.body.appendChild(element);
        element.click();
        document.body.removeChild(element);
    }


    function displayUnsealBtn() {
        const btnElm = document.getElementById('unsealNavBtn');
        btnElm.classList.remove("d-none");
    }

</script>